diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
index fb65e2e..a434fe9 100644
--- a/contrib/postgres_fdw/postgres_fdw.c
+++ b/contrib/postgres_fdw/postgres_fdw.c
@@ -4315,35 +4548,60 @@ foreign_join_ok(PlannerInfo *root, RelOptInfo *joinrel, JoinType jointype,
 
 static void
 add_paths_with_pathkeys_for_rel(PlannerInfo *root, RelOptInfo *rel,
-								Path *epq_path)
+								Path *epq_path, bool grouped)
 {
 	List	   *useful_pathkeys_list = NIL; /* List of all pathkeys */
 	ListCell   *lc;
+	List	   *fdw_private;
+	PathTarget *target = NULL;
 
-	useful_pathkeys_list = get_useful_pathkeys_for_relation(root, rel);
+	useful_pathkeys_list = get_useful_pathkeys_for_relation(root, rel,
+															grouped);
+
+	/*
+	 * Add information to the paths whether they are grouped or not.
+	 */
+	fdw_private = list_make1(makeInteger(grouped ? 1 : 0));
+
+	/*
+	 * Grouped foreign scan should emit tuples according to the grouped
+	 * target, i.e. the one containing GroupedVars.
+	 */
+	if (grouped)
+	{
+		Assert(rel->gpi != NULL);
+		target = rel->gpi->target;
+	}
 
 	/* Create one path for each set of pathkeys we found above. */
 	foreach(lc, useful_pathkeys_list)
 	{
-		double		rows;
-		int			width;
-		Cost		startup_cost;
-		Cost		total_cost;
 		List	   *useful_pathkeys = lfirst(lc);
+		EstimateInfo estimates;
+		Path	*path;
 
 		estimate_path_cost_size(root, rel, NIL, useful_pathkeys,
-								&rows, &width, &startup_cost, &total_cost);
-
-		add_path(rel, (Path *)
-				 create_foreignscan_path(root, rel,
-										 NULL,
-										 rows,
-										 startup_cost,
-										 total_cost,
-										 useful_pathkeys,
-										 NULL,
-										 epq_path,
-										 NIL));
+								&estimates, grouped);
+
+
+		path = (Path *) create_foreignscan_path(root, rel,
+												target,
+												estimates.rows,
+												estimates.startup_cost,
+												estimates.total_cost,
+												useful_pathkeys,
+												NULL,
+												epq_path,
+												fdw_private);
+
+		/*
+		 * Grouped path essentially produces an unique set of grouping
+		 * keys.
+		 */
+		if (grouped)
+			make_uniquekeys_for_agg_path(path);
+
+		add_path(rel, path, grouped);
 	}
 }
 
@@ -4461,35 +4719,51 @@ postgresGetForeignJoinPaths(PlannerInfo *root,
 							RelOptInfo *outerrel,
 							RelOptInfo *innerrel,
 							JoinType jointype,
-							JoinPathExtraData *extra)
+							JoinPathExtraData *extra,
+							bool grouped)
 {
 	PgFdwRelationInfo *fpinfo;
+	EstimateInfo *estimates;
 	ForeignPath *joinpath;
-	double		rows;
-	int			width;
-	Cost		startup_cost;
-	Cost		total_cost;
 	Path	   *epq_path;		/* Path to create plan to be executed when
 								 * EvalPlanQual gets triggered. */
+	bool		first_time;
+	PathTarget *target = NULL;
+	List	   *fdw_private;
 
-	/*
-	 * Skip if this join combination has been considered already.
-	 */
-	if (joinrel->fdw_private)
-		return;
+	if (joinrel->fdw_private == NULL)
+	{
+		/*
+		 * First time through.
+		 *
+		 * Create unfinished PgFdwRelationInfo entry which is used to indicate
+		 * that the join relation is already considered, so that we won't
+		 * waste time in judging safety of join pushdown and adding the same
+		 * paths again if found safe. Once we know that this join can be
+		 * pushed down, we fill the entry.
+		 */
+		fpinfo = (PgFdwRelationInfo *) palloc0(sizeof(PgFdwRelationInfo));
+		fpinfo->pushdown_safe = false;
+		joinrel->fdw_private = fpinfo;
+		/* attrs_used is only for base relations. */
+		fpinfo->attrs_used = NULL;
 
-	/*
-	 * Create unfinished PgFdwRelationInfo entry which is used to indicate
-	 * that the join relation is already considered, so that we won't waste
-	 * time in judging safety of join pushdown and adding the same paths again
-	 * if found safe. Once we know that this join can be pushed down, we fill
-	 * the entry.
-	 */
-	fpinfo = (PgFdwRelationInfo *) palloc0(sizeof(PgFdwRelationInfo));
-	fpinfo->pushdown_safe = false;
-	joinrel->fdw_private = fpinfo;
-	/* attrs_used is only for base relations. */
-	fpinfo->attrs_used = NULL;
+		first_time = true;
+	}
+	else
+	{
+		fpinfo = (PgFdwRelationInfo *) joinrel->fdw_private;
+		first_time = false;
+
+		if (!fpinfo->pushdown_safe)
+		{
+			/*
+			 * The function was already called but some test failed. No reason
+			 * to see that failure again.
+			 */
+			return;
+		}
+	}
 
 	/*
 	 * If there is a possibility that EvalPlanQual will be executed, we need
@@ -4500,27 +4774,78 @@ postgresGetForeignJoinPaths(PlannerInfo *root,
 	 * dominate the only suitable local path available.  We also do it before
 	 * calling foreign_join_ok(), since that function updates fpinfo and marks
 	 * it as pushable if the join is found to be pushable.
+	 *
+	 * The following tests should only be performed once --- repeated, the are
+	 * supposed to yield the same result. (If anything failed initially,
+	 * pushdown_safe should have caused return above.)
 	 */
-	if (root->parse->commandType == CMD_DELETE ||
-		root->parse->commandType == CMD_UPDATE ||
-		root->rowMarks)
+	if (first_time)
 	{
-		epq_path = GetExistingLocalJoinPath(joinrel);
-		if (!epq_path)
+		if (root->parse->commandType == CMD_DELETE ||
+			root->parse->commandType == CMD_UPDATE ||
+			root->rowMarks)
+		{
+			epq_path = GetExistingLocalJoinPath(joinrel);
+			if (!epq_path)
+			{
+				elog(DEBUG3, "could not push down foreign join because a local path suitable for EPQ checks was not found");
+				return;
+			}
+		}
+		else
+			epq_path = NULL;
+
+		if (!foreign_join_ok(root, joinrel, jointype, outerrel, innerrel, extra,
+							 grouped))
 		{
-			elog(DEBUG3, "could not push down foreign join because a local path suitable for EPQ checks was not found");
+			/*
+			 * Free path required for EPQ if we copied one; we don't need it
+			 * now
+			 */
+			if (epq_path)
+				pfree(epq_path);
 			return;
 		}
 	}
-	else
-		epq_path = NULL;
 
-	if (!foreign_join_ok(root, joinrel, jointype, outerrel, innerrel, extra))
-	{
-		/* Free path required for EPQ if we copied one; we don't need it now */
-		if (epq_path)
-			pfree(epq_path);
+	/*
+	 * Local expressions would be evaluated above the grouping plan, which
+	 * will be remote.
+	 */
+	if (grouped && fpinfo->local_conds != NIL)
 		return;
+
+	/*
+	 * This function should not be called repeatedly wit the same value of
+	 * "grouped", but if it happened, make sure the "upper conditions" do not
+	 * get duplicated or used at all if !grouped.
+	 */
+	if (fpinfo->remote_conds_upper)
+	{
+		list_free(fpinfo->remote_conds_upper);
+		fpinfo->remote_conds_upper = NIL;
+	}
+	if (fpinfo->local_conds_upper)
+	{
+		list_free(fpinfo->local_conds_upper);
+		fpinfo->local_conds_upper = NIL;
+	}
+
+	if (grouped)
+	{
+		/*
+		 * Create targelist to be used for the remote grouping.
+		 */
+		Assert(joinrel->gpi != NULL);
+		fpinfo->grouped_tlist = create_remote_agg_tlist(root, joinrel,
+														joinrel->gpi->target);
+
+		/*
+		 * Couldn't push any GROUP BY expression or aggregate to the remote
+		 * server?
+		 */
+		if (fpinfo->grouped_tlist == NIL)
+			return;
 	}
 
 	/*
@@ -4547,16 +4872,44 @@ postgresGetForeignJoinPaths(PlannerInfo *root,
 														0, fpinfo->jointype,
 														extra->sjinfo);
 
+	/*
+	 * Set cached relation costs to some negative value, so that we can detect
+	 * when they are set to some sensible costs, during one (usually the
+	 * first) of the calls to estimate_path_cost_size().
+	 */
+	estimates = !grouped ? &fpinfo->est_plain : &fpinfo->est_grouped;
+	estimates->rel_startup_cost = -1;
+	estimates->rel_total_cost = -1;
+
 	/* Estimate costs for bare join relation */
-	estimate_path_cost_size(root, joinrel, NIL, NIL, &rows,
-							&width, &startup_cost, &total_cost);
+
+	/*
+	 * TODO Include remote_conds_upper and local_conds_upper into the
+	 * estimates.
+	 */
+	estimate_path_cost_size(root, joinrel, NIL, NIL, estimates, grouped);
 	/* Now update this information in the joinrel */
-	joinrel->rows = rows;
-	joinrel->reltarget->width = width;
-	fpinfo->rows = rows;
-	fpinfo->width = width;
-	fpinfo->startup_cost = startup_cost;
-	fpinfo->total_cost = total_cost;
+
+	/*
+	 * TODO If grouped, make sure baserel->gpi exists and store the values
+	 * there.
+	 */
+	joinrel->rows = estimates->rows;
+	joinrel->reltarget->width = estimates->width;
+
+	if (grouped)
+	{
+		/*
+		 * The target must contain aggregates.
+		 */
+		Assert(joinrel->gpi != NULL);
+		target = joinrel->gpi->target;
+	}
+
+	/*
+	 * Add information to the paths whether they are grouped or not.
+	 */
+	fdw_private = list_make1(makeInteger(grouped ? 1 : 0));
 
 	/*
 	 * Create a new join path and add it to the joinrel which represents a
@@ -4564,20 +4917,27 @@ postgresGetForeignJoinPaths(PlannerInfo *root,
 	 */
 	joinpath = create_foreignscan_path(root,
 									   joinrel,
-									   NULL,	/* default pathtarget */
-									   rows,
-									   startup_cost,
-									   total_cost,
+									   target,	/* default pathtarget */
+									   estimates->rows,
+									   estimates->startup_cost,
+									   estimates->total_cost,
 									   NIL, /* no pathkeys */
 									   NULL,	/* no required_outer */
 									   epq_path,
-									   NIL);	/* no fdw_private */
+									   fdw_private);	/* no fdw_private */
+
+	/*
+	 * Grouped path essentially produces an unique set of grouping
+	 * keys.
+	 */
+	if (grouped)
+		make_uniquekeys_for_agg_path((Path *) joinpath);
 
 	/* Add generated path into joinrel by add_path(). */
-	add_path(joinrel, (Path *) joinpath);
+	add_path(joinrel, (Path *) joinpath, grouped);
 
 	/* Consider pathkeys for the join relation */
-	add_paths_with_pathkeys_for_rel(root, joinrel, epq_path);
+	add_paths_with_pathkeys_for_rel(root, joinrel, epq_path, grouped);
 
 	/* XXX Consider parameterized paths for the join relation */
 }
@@ -4593,25 +4953,23 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 	Query	   *query = root->parse;
 	PathTarget *grouping_target;
 	PgFdwRelationInfo *fpinfo = (PgFdwRelationInfo *) grouped_rel->fdw_private;
-	PgFdwRelationInfo *ofpinfo;
-	List	   *aggvars;
-	ListCell   *lc;
-	int			i;
-	List	   *tlist = NIL;
+	PgFdwRelationInfo *ofpinfo = NULL;
 
 	/* Grouping Sets are not pushable */
 	if (query->groupingSets)
 		return false;
 
 	/* Get the fpinfo of the underlying scan relation. */
-	ofpinfo = (PgFdwRelationInfo *) fpinfo->outerrel->fdw_private;
+	if (IS_UPPER_REL(grouped_rel))
+		ofpinfo = (PgFdwRelationInfo *) fpinfo->outerrel->fdw_private;
 
 	/*
 	 * If underneath input relation has any local conditions, those conditions
 	 * are required to be applied before performing aggregation.  Hence the
 	 * aggregate cannot be pushed down.
 	 */
-	if (ofpinfo->local_conds)
+	if ((IS_UPPER_REL(grouped_rel) && ofpinfo->local_conds) ||
+		fpinfo->local_conds)
 		return false;
 
 	/*
@@ -4622,15 +4980,69 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 	 * different from those in the plan's targetlist. Use a copy of path
 	 * target to record the new sortgrouprefs.
 	 */
-	grouping_target = copy_pathtarget(root->upper_targets[UPPERREL_GROUP_AGG]);
+	if (IS_UPPER_REL(grouped_rel))
+		grouping_target = root->upper_targets[UPPERREL_GROUP_AGG];
+	else
+	{
+		/*
+		 * FDW should not be asked to generate grouped paths if the simple or
+		 * join relation has no relevant target.
+		 */
+		Assert(grouped_rel->gpi != NULL);
+		Assert(grouped_rel->gpi->target != NULL);
+
+		grouping_target = grouped_rel->gpi->target;
+	}
+
+	/*
+	 * Create targelist to be sent to the remote server.
+	 */
+	fpinfo->grouped_tlist = create_remote_agg_tlist(root, grouped_rel,
+													grouping_target);
+	if (fpinfo->grouped_tlist == NIL)
+		return false;
+
+	/* Safe to pushdown */
+	fpinfo->pushdown_safe = true;
 
 	/*
-	 * Evaluate grouping targets and check whether they are safe to push down
-	 * to the foreign side.  All GROUP BY expressions will be part of the
-	 * grouping target and thus there is no need to evaluate it separately.
-	 * While doing so, add required expressions into target list which can
-	 * then be used to pass to foreign server.
+	 * Set the string describing this grouped relation to be used in EXPLAIN
+	 * output of corresponding ForeignScan.
 	 */
+	if (ofpinfo != NULL)
+	{
+		fpinfo->relation_name = makeStringInfo();
+		appendStringInfo(fpinfo->relation_name, "Aggregate on (%s)",
+						 ofpinfo->relation_name->data);
+	}
+
+	return true;
+}
+
+/*
+ * Evaluate grouping targets and check whether they are safe to push down to
+ * the foreign side.  All GROUP BY expressions will be part of the grouping
+ * target and thus there is no need to evaluate it separately.  While doing
+ * so, add required expressions into target list which can then be used to
+ * pass to foreign server.
+ *
+ * NIL is returned if the remote aggregation appears to be impossible.
+ *
+ * Note that the function can add items to both remote_conds_upper and
+ * local_conds_upper lists of PgFdwRelationInfo.
+ */
+static List *
+create_remote_agg_tlist(PlannerInfo *root, RelOptInfo *grouped_rel,
+						PathTarget *grouping_target)
+{
+	List	   *tlist = NIL;
+	ListCell   *lc;
+	int			i;
+	Query	   *query = root->parse;
+	PgFdwRelationInfo *fpinfo = (PgFdwRelationInfo *) grouped_rel->fdw_private;
+
+	grouping_target = copy_pathtarget(grouping_target);
+
 	i = 0;
 	foreach(lc, grouping_target->exprs)
 	{
@@ -4646,13 +5058,34 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 			 * push down aggregation to the foreign server.
 			 */
 			if (!is_foreign_expr(root, grouped_rel, expr))
-				return false;
+				return NIL;
 
 			/* Pushable, add to tlist */
 			tlist = add_to_flat_tlist(tlist, list_make1(expr));
 		}
 		else
 		{
+			/*
+			 * Aggregate can sometimes be wrapped by GroupedVar.
+			 *
+			 */
+			if ((IS_SIMPLE_REL(grouped_rel) || IS_JOIN_REL(grouped_rel)) &&
+				IsA(expr, GroupedVar))
+			{
+				GroupedVar *gvar = castNode(GroupedVar, expr);
+
+				/*
+				 * GroupedVar is currently used only to handle Aggrefs.
+				 *
+				 * XXX These may include aggregates that appear in the HAVING
+				 * clause. Although the HAVING clause is currently not sent to
+				 * the remote server (see deparseSelectStmtForRel), we still
+				 * need to send the aggregates the HAVING clause contains.
+				 */
+				Assert(IsA(gvar->agg_partial, Aggref));
+				expr = (Expr *) gvar->agg_partial;
+			}
+
 			/* Check entire expression whether it is pushable or not */
 			if (is_foreign_expr(root, grouped_rel, expr))
 			{
@@ -4661,6 +5094,8 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 			}
 			else
 			{
+				List	   *aggvars;
+
 				/*
 				 * If we have sortgroupref set, then it means that we have an
 				 * ORDER BY entry pointing to this expression.  Since we are
@@ -4669,12 +5104,14 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 				if (sgref)
 					grouping_target->sortgrouprefs[i] = 0;
 
-				/* Not matched exactly, pull the var with aggregates then */
+				/*
+				 * Not matched exactly, pull the var with aggregates then
+				 */
 				aggvars = pull_var_clause((Node *) expr,
 										  PVC_INCLUDE_AGGREGATES);
 
 				if (!is_foreign_expr(root, grouped_rel, (Expr *) aggvars))
-					return false;
+					return NIL;
 
 				/*
 				 * Add aggregates, if any, into the targetlist.  Plain var
@@ -4702,12 +5139,17 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 
 	/*
 	 * Classify the pushable and non-pushable having clauses and save them in
-	 * remote_conds and local_conds of the grouped rel's fpinfo.
+	 * remote_conds_upper and local_conds_upper of the grouped rel's fpinfo.
+	 */
+
+	/*
+	 * TODO For non-upper grouped_rel, only pick those expressions for which
+	 * grouped_rel provides all input vars. (And Assert() that grouped_rel
+	 * does not emit just some of them --- in such a case grouped_rel
+	 * shouldn't be subject to partial aggregation at all.)
 	 */
 	if (root->hasHavingQual && query->havingQual)
 	{
-		ListCell   *lc;
-
 		foreach(lc, (List *) query->havingQual)
 		{
 			Expr	   *expr = (Expr *) lfirst(lc);
@@ -4727,9 +5169,11 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 									  NULL,
 									  NULL);
 			if (is_foreign_expr(root, grouped_rel, expr))
-				fpinfo->remote_conds = lappend(fpinfo->remote_conds, rinfo);
+				fpinfo->remote_conds_upper =
+					lappend(fpinfo->remote_conds_upper, rinfo);
 			else
-				fpinfo->local_conds = lappend(fpinfo->local_conds, rinfo);
+				fpinfo->local_conds_upper =
+					lappend(fpinfo->local_conds_upper, rinfo);
 		}
 	}
 
@@ -4737,12 +5181,11 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 	 * If there are any local conditions, pull Vars and aggregates from it and
 	 * check whether they are safe to pushdown or not.
 	 */
-	if (fpinfo->local_conds)
+	if (fpinfo->local_conds_upper)
 	{
 		List	   *aggvars = NIL;
-		ListCell   *lc;
 
-		foreach(lc, fpinfo->local_conds)
+		foreach(lc, fpinfo->local_conds_upper)
 		{
 			RestrictInfo *rinfo = lfirst_node(RestrictInfo, lc);
 
@@ -4764,7 +5207,7 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 			if (IsA(expr, Aggref))
 			{
 				if (!is_foreign_expr(root, grouped_rel, expr))
-					return false;
+					return NIL;
 
 				tlist = add_to_flat_tlist(tlist, list_make1(expr));
 			}
@@ -4774,29 +5217,7 @@ foreign_grouping_ok(PlannerInfo *root, RelOptInfo *grouped_rel)
 	/* Transfer any sortgroupref data to the replacement tlist */
 	apply_pathtarget_labeling_to_tlist(tlist, grouping_target);
 
-	/* Store generated targetlist */
-	fpinfo->grouped_tlist = tlist;
-
-	/* Safe to pushdown */
-	fpinfo->pushdown_safe = true;
-
-	/*
-	 * Set cached relation costs to some negative value, so that we can detect
-	 * when they are set to some sensible costs, during one (usually the
-	 * first) of the calls to estimate_path_cost_size().
-	 */
-	fpinfo->rel_startup_cost = -1;
-	fpinfo->rel_total_cost = -1;
-
-	/*
-	 * Set the string describing this grouped relation to be used in EXPLAIN
-	 * output of corresponding ForeignScan.
-	 */
-	fpinfo->relation_name = makeStringInfo();
-	appendStringInfo(fpinfo->relation_name, "Aggregate on (%s)",
-					 ofpinfo->relation_name->data);
-
-	return true;
+	return tlist;
 }
 
 /*
@@ -4845,12 +5266,10 @@ add_foreign_grouping_paths(PlannerInfo *root, RelOptInfo *input_rel,
 	Query	   *parse = root->parse;
 	PgFdwRelationInfo *ifpinfo = input_rel->fdw_private;
 	PgFdwRelationInfo *fpinfo = grouped_rel->fdw_private;
+	EstimateInfo *estimates;
 	ForeignPath *grouppath;
 	PathTarget *grouping_target;
-	double		rows;
-	int			width;
-	Cost		startup_cost;
-	Cost		total_cost;
+	List	*fdw_private;
 
 	/* Nothing to be done, if there is no grouping or aggregation required. */
 	if (!parse->groupClause && !parse->groupingSets && !parse->hasAggs &&
@@ -4876,29 +5295,29 @@ add_foreign_grouping_paths(PlannerInfo *root, RelOptInfo *input_rel,
 		return;
 
 	/* Estimate the cost of push down */
-	estimate_path_cost_size(root, grouped_rel, NIL, NIL, &rows,
-							&width, &startup_cost, &total_cost);
+	estimates = &fpinfo->est_grouped;
+	estimate_path_cost_size(root, grouped_rel, NIL, NIL, estimates, true);
 
-	/* Now update this information in the fpinfo */
-	fpinfo->rows = rows;
-	fpinfo->width = width;
-	fpinfo->startup_cost = startup_cost;
-	fpinfo->total_cost = total_cost;
+	/*
+	 * The path is considered grouped when it comes to plan creation and
+	 * deparsing.
+	 */
+	fdw_private = list_make1(makeInteger(1));
 
 	/* Create and add foreign path to the grouping relation. */
 	grouppath = create_foreignscan_path(root,
 										grouped_rel,
 										grouping_target,
-										rows,
-										startup_cost,
-										total_cost,
+										estimates->rows,
+										estimates->startup_cost,
+										estimates->total_cost,
 										NIL,	/* no pathkeys */
 										NULL,	/* no required_outer */
 										NULL,
-										NIL);	/* no fdw_private */
+										fdw_private);
 
 	/* Add generated path into grouped_rel by add_path(). */
-	add_path(grouped_rel, (Path *) grouppath);
+	add_path(grouped_rel, (Path *) grouppath, false);
 }
 
 /*
diff --git a/contrib/postgres_fdw/postgres_fdw.h b/contrib/postgres_fdw/postgres_fdw.h
index 788b003..e796236 100644
--- a/contrib/postgres_fdw/postgres_fdw.h
+++ b/contrib/postgres_fdw/postgres_fdw.h
@@ -20,6 +20,18 @@
 
 #include "libpq-fe.h"
 
+typedef struct EstimateInfo
+{
+	/* Estimated size and cost for a scan or join. */
+	double		rows;
+	int			width;
+	Cost		startup_cost;
+	Cost		total_cost;
+	/* Costs excluding costs for transferring data from the foreign server */
+	Cost		rel_startup_cost;
+	Cost		rel_total_cost;
+}			EstimateInfo;
+
 /*
  * FDW-specific planner information kept in RelOptInfo.fdw_private for a
  * postgres_fdw foreign table.  For a baserel, this struct is created by
@@ -43,6 +55,14 @@ typedef struct PgFdwRelationInfo
 	List	   *remote_conds;
 	List	   *local_conds;
 
+	/*
+	 * HAVING clauses.
+	 *
+	 * TODO Use these where appropriate.
+	 */
+	List	   *remote_conds_upper;
+	List	   *local_conds_upper;
+
 	/* Actual remote restriction clauses for scan (sans RestrictInfos) */
 	List	   *final_remote_exprs;
 
@@ -56,14 +76,9 @@ typedef struct PgFdwRelationInfo
 	/* Selectivity of join conditions */
 	Selectivity joinclause_sel;
 
-	/* Estimated size and cost for a scan or join. */
-	double		rows;
-	int			width;
-	Cost		startup_cost;
-	Cost		total_cost;
-	/* Costs excluding costs for transferring data from the foreign server */
-	Cost		rel_startup_cost;
-	Cost		rel_total_cost;
+	/* Estimates for both plain and grouped relation. */
+	EstimateInfo est_plain;
+	EstimateInfo est_grouped;
 
 	/* Options extracted from catalogs. */
 	bool		use_remote_estimate;
@@ -92,7 +107,9 @@ typedef struct PgFdwRelationInfo
 	/* joinclauses contains only JOIN/ON conditions for an outer join */
 	List	   *joinclauses;	/* List of RestrictInfo */
 
-	/* Grouping information */
+	/*
+	 * The targetlist used to construct the remote query.
+	 */
 	List	   *grouped_tlist;
 
 	/* Subquery information */
@@ -121,6 +138,7 @@ extern unsigned int GetCursorNumber(PGconn *conn);
 extern unsigned int GetPrepStmtNumber(PGconn *conn);
 extern PGresult *pgfdw_get_result(PGconn *conn, const char *query);
 extern PGresult *pgfdw_exec_query(PGconn *conn, const char *query);
+extern void pgfdw_send_query(PGconn *conn, const char *query);
 extern void pgfdw_report_error(int elevel, PGresult *res, PGconn *conn,
 				   bool clear, const char *sql);
 
@@ -175,7 +193,8 @@ extern List *build_tlist_to_deparse(RelOptInfo *foreignrel);
 extern void deparseSelectStmtForRel(StringInfo buf, PlannerInfo *root,
 						RelOptInfo *foreignrel, List *tlist,
 						List *remote_conds, List *pathkeys, bool is_subquery,
-						List **retrieved_attrs, List **params_list);
+						List **retrieved_attrs, List **params_list,
+						bool grouping);
 extern const char *get_jointype_name(JoinType jointype);
 
 /* in shippable.c */
diff --git a/contrib/postgres_fdw/sql/postgres_fdw.sql b/contrib/postgres_fdw/sql/postgres_fdw.sql
index 1df1e3a..c421530 100644
--- a/contrib/postgres_fdw/sql/postgres_fdw.sql
+++ b/contrib/postgres_fdw/sql/postgres_fdw.sql
@@ -292,7 +292,7 @@ RESET enable_nestloop;
 EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft1 t1 WHERE t1.c1 = 1;         -- Var, OpExpr(b), Const
 EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft1 t1 WHERE t1.c1 = 100 AND t1.c2 = 0; -- BoolExpr
 EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft1 t1 WHERE c1 IS NULL;        -- NullTest
-EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft1 t1 WHERE c1 IS NOT NULL;    -- NullTest
+EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft1 t1 WHERE c1 IS NOT NULL and c3 is not null;    -- NullTest
 EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft1 t1 WHERE round(abs(c1), 0) = 1; -- FuncExpr
 EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft1 t1 WHERE c1 = -c1;          -- OpExpr(l)
 EXPLAIN (VERBOSE, COSTS OFF) SELECT * FROM ft1 t1 WHERE 1 = c1!;           -- OpExpr(r)
diff --git a/src/backend/executor/execExpr.c b/src/backend/executor/execExpr.c
index e083961..6be6b70 100644
--- a/src/backend/executor/execExpr.c
+++ b/src/backend/executor/execExpr.c
@@ -723,6 +723,37 @@ ExecInitExprRec(Expr *node, PlanState *parent, ExprState *state,
 				break;
 			}
 
+		case T_GroupedVar:
+
+			/*
+			 * If GroupedVar appears in targetlist of Agg node, it can
+			 * represent either Aggref or grouping expression.
+			 */
+			if (parent && (IsA(parent, AggState)))
+			{
+				GroupedVar *gvar = (GroupedVar *) node;
+
+				/*
+				 * TODO Assert() that all Aggrefs of the AggState are partial:
+				 * GroupedVar shouldn't find its way to the query targetlist.
+				 */
+				if (IsA(gvar->gvexpr, Aggref))
+					ExecInitExprRec((Expr *) gvar->agg_partial, parent, state,
+									resv, resnull);
+				else
+					ExecInitExprRec((Expr *) gvar->gvexpr, parent, state,
+									resv, resnull);
+				break;
+			}
+			else
+			{
+				/*
+				 * set_plan_refs should have replaced GroupedVar in the
+				 * targetlist with an ordinary Var.
+				 */
+				elog(ERROR, "parent of GroupedVar is not Agg node");
+			}
+
 		case T_GroupingFunc:
 			{
 				GroupingFunc *grp_node = (GroupingFunc *) node;
diff --git a/src/backend/executor/nodeAgg.c b/src/backend/executor/nodeAgg.c
index da6ef1a..2dabe4c 100644
--- a/src/backend/executor/nodeAgg.c
+++ b/src/backend/executor/nodeAgg.c
@@ -1875,6 +1875,13 @@ find_unaggregated_cols_walker(Node *node, Bitmapset **colnos)
 		/* do not descend into aggregate exprs */
 		return false;
 	}
+	if (IsA(node, GroupedVar))
+	{
+		GroupedVar *gvar = (GroupedVar *) node;
+
+		if (IsA(gvar->gvexpr, Aggref))
+			return false;
+	}
 	return expression_tree_walker(node, find_unaggregated_cols_walker,
 								  (void *) colnos);
 }
diff --git a/src/backend/nodes/copyfuncs.c b/src/backend/nodes/copyfuncs.c
index aff9a62..371dda1 100644
--- a/src/backend/nodes/copyfuncs.c
+++ b/src/backend/nodes/copyfuncs.c
@@ -1359,6 +1359,8 @@ _copyAggref(const Aggref *from)
 	COPY_SCALAR_FIELD(aggcollid);
 	COPY_SCALAR_FIELD(inputcollid);
 	COPY_SCALAR_FIELD(aggtranstype);
+	COPY_SCALAR_FIELD(aggcombinefn);
+	COPY_SCALAR_FIELD(aggfinalfn);
 	COPY_NODE_FIELD(aggargtypes);
 	COPY_NODE_FIELD(aggdirectargs);
 	COPY_NODE_FIELD(args);
@@ -2211,6 +2213,22 @@ _copyPlaceHolderVar(const PlaceHolderVar *from)
 }
 
 /*
+ * _copyGroupedVar
+ */
+static GroupedVar *
+_copyGroupedVar(const GroupedVar *from)
+{
+	GroupedVar *newnode = makeNode(GroupedVar);
+
+	COPY_NODE_FIELD(gvexpr);
+	COPY_NODE_FIELD(agg_partial);
+	COPY_SCALAR_FIELD(sortgroupref);
+	COPY_SCALAR_FIELD(gvid);
+
+	return newnode;
+}
+
+/*
  * _copySpecialJoinInfo
  */
 static SpecialJoinInfo *
@@ -2283,6 +2301,21 @@ _copyPlaceHolderInfo(const PlaceHolderInfo *from)
 	return newnode;
 }
 
+static GroupedVarInfo *
+_copyGroupedVarInfo(const GroupedVarInfo *from)
+{
+	GroupedVarInfo *newnode = makeNode(GroupedVarInfo);
+
+	COPY_SCALAR_FIELD(gvid);
+	COPY_NODE_FIELD(gvexpr);
+	COPY_NODE_FIELD(agg_partial);
+	COPY_SCALAR_FIELD(sortgroupref);
+	COPY_SCALAR_FIELD(gv_eval_at);
+	COPY_SCALAR_FIELD(gv_width);
+
+	return newnode;
+}
+
 /* ****************************************************************
  *					parsenodes.h copy functions
  * ****************************************************************
@@ -5018,6 +5051,9 @@ copyObjectImpl(const void *from)
 		case T_PlaceHolderVar:
 			retval = _copyPlaceHolderVar(from);
 			break;
+		case T_GroupedVar:
+			retval = _copyGroupedVar(from);
+			break;
 		case T_SpecialJoinInfo:
 			retval = _copySpecialJoinInfo(from);
 			break;
@@ -5030,6 +5066,9 @@ copyObjectImpl(const void *from)
 		case T_PlaceHolderInfo:
 			retval = _copyPlaceHolderInfo(from);
 			break;
+		case T_GroupedVarInfo:
+			retval = _copyGroupedVarInfo(from);
+			break;
 
 			/*
 			 * VALUE NODES
diff --git a/src/backend/nodes/equalfuncs.c b/src/backend/nodes/equalfuncs.c
index 2e869a9..3d735a2 100644
--- a/src/backend/nodes/equalfuncs.c
+++ b/src/backend/nodes/equalfuncs.c
@@ -873,6 +873,14 @@ _equalPlaceHolderVar(const PlaceHolderVar *a, const PlaceHolderVar *b)
 }
 
 static bool
+_equalGroupedVar(const GroupedVar *a, const GroupedVar *b)
+{
+	COMPARE_SCALAR_FIELD(gvid);
+
+	return true;
+}
+
+static bool
 _equalSpecialJoinInfo(const SpecialJoinInfo *a, const SpecialJoinInfo *b)
 {
 	COMPARE_BITMAPSET_FIELD(min_lefthand);
@@ -3171,6 +3179,9 @@ equal(const void *a, const void *b)
 		case T_PlaceHolderVar:
 			retval = _equalPlaceHolderVar(a, b);
 			break;
+		case T_GroupedVar:
+			retval = _equalGroupedVar(a, b);
+			break;
 		case T_SpecialJoinInfo:
 			retval = _equalSpecialJoinInfo(a, b);
 			break;
diff --git a/src/backend/nodes/nodeFuncs.c b/src/backend/nodes/nodeFuncs.c
index c2a93b2..9a53aa7 100644
--- a/src/backend/nodes/nodeFuncs.c
+++ b/src/backend/nodes/nodeFuncs.c
@@ -259,6 +259,12 @@ exprType(const Node *expr)
 		case T_PlaceHolderVar:
 			type = exprType((Node *) ((const PlaceHolderVar *) expr)->phexpr);
 			break;
+		case T_GroupedVar:
+			if (IsA(((const GroupedVar *) expr)->gvexpr, Aggref))
+				type = exprType((Node *) ((const GroupedVar *) expr)->agg_partial);
+			else
+				type = exprType((Node *) ((const GroupedVar *) expr)->gvexpr);
+			break;
 		default:
 			elog(ERROR, "unrecognized node type: %d", (int) nodeTag(expr));
 			type = InvalidOid;	/* keep compiler quiet */
@@ -492,6 +498,11 @@ exprTypmod(const Node *expr)
 			return ((const SetToDefault *) expr)->typeMod;
 		case T_PlaceHolderVar:
 			return exprTypmod((Node *) ((const PlaceHolderVar *) expr)->phexpr);
+		case T_GroupedVar:
+			if (IsA(((const GroupedVar *) expr)->gvexpr, Aggref))
+				return exprTypmod((Node *) ((const GroupedVar *) expr)->agg_partial);
+			else
+				return exprTypmod((Node *) ((const GroupedVar *) expr)->gvexpr);
 		default:
 			break;
 	}
@@ -903,6 +914,12 @@ exprCollation(const Node *expr)
 		case T_PlaceHolderVar:
 			coll = exprCollation((Node *) ((const PlaceHolderVar *) expr)->phexpr);
 			break;
+		case T_GroupedVar:
+			if (IsA(((const GroupedVar *) expr)->gvexpr, Aggref))
+				coll = exprCollation((Node *) ((const GroupedVar *) expr)->agg_partial);
+			else
+				coll = exprCollation((Node *) ((const GroupedVar *) expr)->gvexpr);
+			break;
 		default:
 			elog(ERROR, "unrecognized node type: %d", (int) nodeTag(expr));
 			coll = InvalidOid;	/* keep compiler quiet */
@@ -2176,6 +2193,8 @@ expression_tree_walker(Node *node,
 			break;
 		case T_PlaceHolderVar:
 			return walker(((PlaceHolderVar *) node)->phexpr, context);
+		case T_GroupedVar:
+			return walker(((GroupedVar *) node)->gvexpr, context);
 		case T_InferenceElem:
 			return walker(((InferenceElem *) node)->expr, context);
 		case T_AppendRelInfo:
@@ -2968,6 +2987,16 @@ expression_tree_mutator(Node *node,
 				return (Node *) newnode;
 			}
 			break;
+		case T_GroupedVar:
+			{
+				GroupedVar *gv = (GroupedVar *) node;
+				GroupedVar *newnode;
+
+				FLATCOPY(newnode, gv, GroupedVar);
+				MUTATE(newnode->gvexpr, gv->gvexpr, Expr *);
+				MUTATE(newnode->agg_partial, gv->agg_partial, Aggref *);
+				return (Node *) newnode;
+			}
 		case T_InferenceElem:
 			{
 				InferenceElem *inferenceelemdexpr = (InferenceElem *) node;
